/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */


package org.ow2.petals.databinding.jaxb.service;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;


/**
 * 
 * @author Mohammed EL JAI
 *
 */

public class Operation {
    
    /** **/
    private Service serviceOfOperation;
	
	/** **/
	private String operationName;
	
	/** **/
	private String soapActionName;
	
	/** **/
	private Message inputMessage; 
	
	/** **/
	private Message outputMessage;
	
	/** **/
	private Class<?>[]parameterTypes;
	
	/** **/
	private Type[] genericParameterTypes;
	
	/** The method return type, null if the return type is void **/
	private Class<?> returnType;
	
	/** **/
	private Type genericReturnType;
	
	/** **/
	private Class<?>[] exceptionType;
	
	/** **/
	private List<Message> operationFaults;
	
	
	/**
	 * 
	 */
	public Operation() {
	    setOperationFaults(new ArrayList<Message>());
	}
	
	/**
	 * 
	 * @param operationName
	 * @param soapActionName
	 * @param inputMessage
	 * @param outputMessage
	 */
	public Operation(String operationName, String soapActionName,
			Message inputMessage, Message outputMessage) {
		super();
		this.operationName = operationName;
		this.soapActionName = soapActionName;
		this.inputMessage = inputMessage;
		this.outputMessage = outputMessage;
	}
	
	
	
	public String getOperationName() {
		return operationName;
	}

	public void setOperationName(String operationName) {
		this.operationName = operationName;
	}

	public String getSoapActionName() {
		return soapActionName;
	}

	public void setSoapActionName(String soapActionName) {
		this.soapActionName = soapActionName;
	}

	public Message getInputMessage() {
		return inputMessage;
	}

	public void setInputMessage(Message inputMessage) {
		this.inputMessage = inputMessage;
	}

	public Message getOutputMessage() {
		return outputMessage;
	}

	public void setOutputMessage(Message otputMessage) {
		this.outputMessage = otputMessage;
	}

	public void setParameterTypes(Class<?>[] parameterTypes) {
		this.parameterTypes = parameterTypes;
	}

	public Class<?>[] getParameterTypes() {
		return parameterTypes;
	}

	public void setReturnType(Class<?> returnType) {
		this.returnType = returnType;
	}

	public Class<?> getReturnType() {
		return returnType;
	}

	public void setGenericParameterTypes(Type[] genericParameterTypes) {
		this.genericParameterTypes = genericParameterTypes;
	}

	public Type[] getGenericParameterTypes() {
		return genericParameterTypes;
	}

	public void setGenericReturnType(Type genericReturnType) {
		this.genericReturnType = genericReturnType;
	}

	public Type getGenericReturnType() {
		return genericReturnType;
	}

    public void setExceptionType(Class<?>[] exceptionType) {
        this.exceptionType = exceptionType;
    }

    public Class<?>[] getExceptionType() {
        return exceptionType;
    }

    public void setOperationFaults(List<Message> operationFaults) {
        this.operationFaults = operationFaults;
    }

    public List<Message> getOperationFaults() {
        return operationFaults;
    }

    public void setServiceOfOperation(Service serviceOfOperation) {
        this.serviceOfOperation = serviceOfOperation;
    }

    public Service getServiceOfOperation() {
        return serviceOfOperation;
    }


	
	
}
